# developer Genai - Full Documentation # Access Models API with Apex The Models API provides Apex classes that connect your application to large language models (LLMs). These Apex classes are autogenerated from the Models REST API specification using [External Services](https://help.salesforce.com/s/articleView?id=platform.external_services.htm). **note:** All Models API requests are subject to Salesforce’s usage and billing rates for Einstein Requests. See [Agentforce and Generative AI Usage and Billing](https://help.salesforce.com/s/articleView?id=ai.generative_ai_usage.htm) and the [Rate Card for Einstein Requests](https://www.salesforce.com/products/einstein/skus/). The Apex methods of the Models API are also subject to the Apex [Callout Limits and Limitations](https://developer.salesforce.com/docs/atlas.en-us.apexcode.meta/apexcode/apex_callouts_timeouts.htm). ## Pick a Method The [ModelsAPI](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#modelsapi) class in the `aiplatform` namespace provides a method for these generative AI capabilities. | Capability | Method Name | Description | | ------------------- | -------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | | Generate Chat | [`createChatGenerations`](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createchatgenerations) | Generate a response based on a list of messages representing a chat conversation. | | Generate Embeddings | [`createEmbeddings`](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createembeddings) | Create an embedding vector representing the input text. | | Generate Text | [`createGenerations`](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#creategenerations) | Generate a response based on the prompt provided. | | Submit Feedback | [`submitFeedback`](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#submitfeedback) | Submit feedback for generated text. | ## Choose a Model Each method, other than `submitFeedback`, requires the API name of the model as part of the request. For instance, if you want to use the OpenAI GPT-4o mini model for a generation request, specify the API name `sfdc_ai__DefaultOpenAIGPT4OmniMini` in the request. The Models API supports models from various Salesforce-enabled providers. See [Supported Models](https://developer.salesforce.com/docs/ai/agentforce/supported-models.md). ## Write Apex Code These examples demonstrate how to use Apex to communicate with the Models API. ### Generate Text To generate text, call the `ModelsAPI.createGenerations()` method with a prompt in your request body. If the request is successful, the response contains the generated text in the `Code200.generation.generatedText` field. If there’s an error, a `ModelsAPI.createGenerations_ResponseException` exception is thrown. ```apex // Create generate text request aiplatform.ModelsAPI.createGenerations_Request request = new aiplatform.ModelsAPI.createGenerations_Request(); // Specify model request.modelName = 'sfdc_ai__DefaultOpenAIGPT4OmniMini'; // Create request body aiplatform.ModelsAPI_GenerationRequest requestBody = new aiplatform.ModelsAPI_GenerationRequest(); request.body = requestBody; // Add prompt to body requestBody.prompt = 'Generate a welcome email for the new developer on the team, Jane Doe.'; try { // Make request aiplatform.ModelsAPI modelsAPI = new aiplatform.ModelsAPI(); aiplatform.ModelsAPI.createGenerations_Response response = modelsAPI.createGenerations(request); System.debug('Models API response: ' + response.Code200.generation.generatedText); // Handle error } catch(aiplatform.ModelsAPI.createGenerations_ResponseException e) { System.debug('Response code: ' + e.responseCode); System.debug('The following exception occurred: ' + e); } ``` ### Generate Chat To generate a chat message, call the [ModelsAPI.createChatGenerations](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createchatgenerations) method with a chronological list of chat messages in your request body. If the request is successful, the response contains the chat messages in the `Code200.generationDetails.generations` field. If there’s an error, a [ModelsAPI.createChatGenerations_ResponseException](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createchatgenerations_responseexception) exception is thrown. ```apex // Create generate chat request aiplatform.ModelsAPI.createChatGenerations_Request request = new aiplatform.ModelsAPI.createChatGenerations_Request(); // Specify model request.modelName = 'sfdc_ai__DefaultOpenAIGPT4OmniMini'; // Create request body aiplatform.ModelsAPI_ChatGenerationsRequest body = new aiplatform.ModelsAPI_ChatGenerationsRequest(); request.body = body; // Add chat messages to body List messagesList = new List (); aiplatform.ModelsAPI_ChatMessageRequest systemMessage = new aiplatform.ModelsAPI_ChatMessageRequest(); systemMessage.content = 'Make this request a little silly.'; systemMessage.role = 'system'; messagesList.add(systemMessage); aiplatform.ModelsAPI_ChatMessageRequest userMessage = new aiplatform.ModelsAPI_ChatMessageRequest(); userMessage.content = 'Can you give me a recipe for cherry pie?'; userMessage.role = 'user'; messagesList.add(userMessage); body.messages = messagesList; try { // Make request aiplatform.ModelsAPI modelsAPI = new aiplatform.ModelsAPI(); aiplatform.ModelsAPI.createChatGenerations_Response response = modelsAPI.createChatGenerations(request); System.debug('Models API response: ' + response.Code200.generationDetails.generations); // Handle error } catch(aiplatform.ModelsAPI.createChatGenerations_ResponseException e) { System.debug('Response code: ' + e.responseCode); System.debug('The following exception occurred: ' + e); } ``` ### Generate Embeddings To generate embeddings, call the [ModelsAPI.createEmbeddings](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createembeddings) method with the input text in your request body. If the request is successful, the response contains the embeddings vector in the `Code200.embeddings` field. If there’s an error, a [ModelsAPI.createEmbeddings_ResponseException](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createembeddings_responseexception) exception is thrown. ```apex // Create generate embeddings request aiplatform.ModelsAPI.createEmbeddings_Request request = new aiplatform.ModelsAPI.createEmbeddings_Request(); // Specify model request.modelName = 'sfdc_ai__DefaultOpenAITextEmbeddingAda_002'; // Create request body aiplatform.ModelsAPI_EmbeddingRequest body = new aiplatform.ModelsAPI_EmbeddingRequest(); request.body = body; // Add input to body List inputList = new List (); inputList.add('Every day, once a day, give yourself a present'); body.input = inputList; try { // Make request aiplatform.ModelsAPI modelsAPI = new aiplatform.ModelsAPI(); aiplatform.ModelsAPI.createEmbeddings_Response response = modelsAPI.createEmbeddings(request); System.debug('Models API response: ' + response.Code200.embeddings); // Handle error } catch(aiplatform.ModelsAPI.createEmbeddings_ResponseException e) { System.debug('Response code: ' + e.responseCode); System.debug('The following exception occurred: ' + e); } ``` ### Submit Feedback To submit feedback, call the [ModelsAPI.submitFeedback](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#submitfeedback) method with feedback information in your request body. If there’s an error, a [ModelsAPI.submitFeedback_ResponseException](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html#createembeddings_responseexception) exception is thrown. ```apex // Create submit feedback request aiplatform.ModelsAPI.submitFeedback_Request request = new aiplatform.ModelsAPI.submitFeedback_Request(); // Provide feedback information in body aiplatform.ModelsAPI_FeedbackRequest feedbackRequest = new aiplatform.ModelsAPI_FeedbackRequest(); feedbackRequest.id = '78w60870345-2335840385-4857348-803483'; feedbackRequest.generationId = '89t608-46756v66y-23r4wqxe43-096mi'; feedbackRequest.feedback = 'GOOD'; feedbackRequest.feedbackText = 'The generation was helpful and did not require any changes'; feedbackRequest.source = 'HUMAN'; request.body = feedbackRequest; try { // Submit feedback aiplatform.ModelsAPI modelsAPI = new aiplatform.ModelsAPI(); aiplatform.ModelsAPI.submitFeedback_Response response = modelsAPI.submitFeedback(request); System.debug('Models API response: ' + response.Code202.message); // Handle error } catch(aiplatform.ModelsAPI.submitFeedback_ResponseException e) { System.debug('Response code: ' + e.responseCode); System.debug('The following exception occurred: ' + e); } ``` ## Test Your Apex These Apex classes are based on an [External Services](https://help.salesforce.com/s/articleView?id=platform.external_services.htm) framework. For guidance on testing your Apex, refer to the Apex Developer Guide, and information about External Services. - _Apex Developer Guide_: [Testing Apex](https://developer.salesforce.com/docs/atlas.en-us.apexcode.meta/apexcode/apex_testing.htm) - _Salesforce Help_: [Testing External Services](https://help.salesforce.com/s/articleView?id=platform.external_services_test_actions_in_flow.htm) ## Next Steps To optimize your implementation, refer to these topics. - [Build Lightning Web Components and Flows with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-build-lwc-flow.md) - [Supported Models](https://developer.salesforce.com/docs/ai/agentforce/supported-models.md) - [Rate Limits for Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-rate-limits.md) - [Models API Apex Reference](/docs/ai/agentforce/references/models-apex-api/models-apex-reference.html) - [Specify Languages and Locales with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-languages-and-locales.md) ## See Also - _Salesforce Help_: [About Einstein Generative AI](https://help.salesforce.com/s/articleView?id=ai.generative_ai_about.htm) - _Models API Developer Guide_: [Access Models API with REST](https://developer.salesforce.com/docs/ai/agentforce/guide/access-models-api-with-rest.md) - _Apex Developer Guide_: [Getting Started with Apex](https://developer.salesforce.com/docs/atlas.en-us.apexcode.meta/apexcode/apex_intro_get_started.htm) - _Trailhead_: [Get Started with the Models API](https://trailhead.salesforce.com/content/learn/modules/get-started-with-einstein-models-api) # Access Models API with REST The Models REST API connects your application to large language models (LLMs) for chat, embeddings, text generation, and feedback. Before you make a request, complete the shared authentication flow to create a Salesforce app and generate a JSON Web Token (JWT). See [Authenticate to the Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-authentication.md). Then use your token to call the endpoints described here. **note:** All Models API requests are subject to Salesforce’s usage and billing rates for Einstein Requests. See [Agentforce and Generative AI Usage and Billing](https://help.salesforce.com/s/articleView?id=ai.generative_ai_usage.htm) and the [Rate Card for Einstein Requests](https://www.salesforce.com/products/einstein/skus/). ## Postman Collection The quickest way to get started with the Models REST API is with our [Postman collection](https://www.postman.com/salesforce-developers/workspace/salesforce-developers/collection/12721794-582bb775-b99d-46d8-88cf-df0d3a341040). ## Call the Models REST API When you have a valid token, you can call any of the Models REST API endpoints. ### Pick a Capability The Models REST API provides four different endpoints for four different capabilities. | Capability | Endpoint Path | Description | | ------------------- | ---------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | | Generate Chat | [`/models/{modelName}/chat-generations`](/docs/ai/agentforce/references/models-api#operation/generateChat) | Generate a response based on a list of messages representing a chat conversation. | | Generate Embeddings | [`/models/{modelName}/embeddings`](/docs/ai/agentforce/references/models-api#operation/generateEmbeddings) | Create an embedding vector representing the input text. | | Generate Text | [`/models/{modelName}/generations`](/docs/ai/agentforce/references/models-api#operation/generateText) | Generate a response based on the prompt provided. | | Submit Feedback | [`/feedback`](/docs/ai/agentforce/references/models-api#operation/submitFeedback) | Submit feedback for generated text. | ### Choose a Model Choose a model to use when you call the generations or embeddings endpoints. Each endpoint, other than the feedback endpoint, requires the API name of the model as part of the path. For instance, if you want to use the OpenAI GPT-4o mini model for a generation request, specify the API name `sfdc_ai__DefaultOpenAIGPT4OmniMini` by making a request to this endpoint. ```bash https://api.salesforce.com/einstein/platform/v1/models/sfdc_ai__DefaultOpenAIGPT4OmniMini/generations ``` The Models API supports models from various Salesforce-enabled providers. See [Supported Models](https://developer.salesforce.com/docs/ai/agentforce/supported-models.md). ### Provide Headers These headers are relevant for API requests. | Header | Description | Example | | --------------------- | ----------------------------------------------------------------------------------------------------- | ---------------------------------- | | `Authorization` | Required. Authorization method for this request. This header must contain your JWT. | `Bearer {token}` | | `Content-Type` | Required. Specify the `application/json` content type. | `application/json` | | `x-sfdc-app-context` | Required. This value is reserved for future use. For now, specify `EinsteinGPT`. | `EinsteinGPT` | | `x-client-feature-id` | Required. This value is reserved for future use. For now, specify `ai-platform-models-connected-app`. | `ai-platform-models-connected-app` | ### Make a Request Make a POST request to one of [the Models REST API endpoints](/docs/ai/agentforce/references/models-api?meta=summary). This example demonstrates a call to the `generations` endpoint. ```bash curl --location 'https://api.salesforce.com/einstein/platform/v1/models/sfdc_ai__DefaultOpenAIGPT4OmniMini/generations' \ --header 'Authorization: Bearer ••••••' \ --header 'Content-Type: application/json' \ --header 'x-sfdc-app-context: EinsteinGPT' \ --header 'x-client-feature-id: ai-platform-models-connected-app' \ --data '{ "prompt": "James Lee is a financial advisor, living in San Diego. His phone number is 867-5309. Generate a story about his work and life." }' ``` **tip:** If you receive a `401` or `404` response code, verify that your Salesforce app includes all the required scopes and settings, and that you're using the complete `access_token` value that you generated. See [Authenticate to the Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-authentication.md). And here’s a sample response. ```json { "id": "chatcmpl-9AMuFltdq7M5ntZVvQcAkgyWhfoas", "generation": { "id": "333127bd-2d5d-41e8-9781-59a1a18ed69f", "generatedText": "Once upon a time in sunny San Diego, there lived a diligent and experienced financial advisor named James Lee. With a passion for numbers and a knack for helping others achieve their financial goals, James had built a reputation as a trusted advisor in the community.\n\nJames had always been fascinated by the world of finance. From a young age, he would spend hours poring over financial newspapers and studying the stock market. As he grew older, his passion only intensified, leading him to pursue a degree in finance from a prestigious university...", "contentQuality": { "scanToxicity": { "isDetected": false, "categories": [ { "categoryName": "identity", "score": 2.0e-5, }, { "categoryName": "hate", "score": 0.0, }, { "categoryName": "profanity", "score": 3.0e-5, }, { "categoryName": "violence", "score": 2.0e-5, }, { "categoryName": "sexual", "score": 1.5e-4, }, { "categoryName": "physical", "score": 0.0, } ] } }, "parameters": { "finish_reason": "stop", "index": 0, "logprobs": null } }, "moreGenerations": null, "prompt": null, "parameters": { "created": 1712258359, "usage": { "completion_tokens": 607, "prompt_tokens": 39, "total_tokens": 646 }, "model": "gpt-35-turbo", "system_fingerprint": null, "object": "chat.completion" } } ``` ## Next Steps After you successfully call the API, refer to these topics to optimize your implementation. - [Supported Models](https://developer.salesforce.com/docs/ai/agentforce/supported-models.md) - [Rate Limits for Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-rate-limits.md) - [Specify Languages and Locales with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-languages-and-locales.md) - [Toxicity Scoring with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-toxicity-scoring.md) - [Data Masking with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-data-masking.md) - [Get Generation Feedback Using Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-feedback.md) - [Access Models API with Apex](https://developer.salesforce.com/docs/ai/agentforce/guide/access-models-api-with-apex.md) - [Build Lightning Web Components and Flows with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-build-lwc-flow.md) - [Models REST API Reference](/docs/ai/agentforce/references/models-api?meta=summary) ## See Also - _Salesforce Help_: [Agentforce and Einstein Generative AI](https://help.salesforce.com/s/articleView?id=ai.generative_ai.htm) - _Salesforce Help_: [External Client Apps](https://help.salesforce.com/s/articleView?id=xcloud.external_client_apps.htm) # Access Predictive Endpoints with REST The predictive endpoints of the Models API are REST-only. Authenticate with the same JWT flow used by the generative endpoints, then `POST` to the predictive endpoint for the capability you need. ## Authenticate Predictive endpoints use the same JWT authentication flow as the generative REST endpoints. To create an external client app, generate a JWT, and set up your authorization header, see [Authenticate to the Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/models-api-authentication.md). ## Call a Predictive Endpoint Predictive endpoints follow this shape: ``` POST /einstein/platform/v1/models/{modelApiName}/{method} ``` Where `{method}` is one of: | Capability | Endpoint Path | Predicts | | -------------------- | ----------------------- | --------------------------------- | | Regression | `/regression` | A continuous numeric value. | | Forecast | `/forecast` | Future values of a time series. | | Classification | `/classification` | A probability per class. | | Multi-Outcome | `/multi-outcome` | Several outcomes for each record. | | Topic Classification | `/topic-classification` | Caller-supplied topics for texts. | | Sentiment Detection | `/sentiment-detection` | Sentiment for a batch of texts. | ## See Also - [Predict with Models API](https://developer.salesforce.com/docs/ai/agentforce/guide/predict-with-models-api.md) - [Access Models API with REST](https://developer.salesforce.com/docs/ai/agentforce/guide/access-models-api-with-rest.md) # Add Custom Evaluation Criteria to a Test Case To test an agent response for specific strings or numbers, you can create custom evaluations. This enables you to create test cases for any data in an agent response, extending testing capabilities beyond standard or out-of-the-box expectations. Custom evaluations enable more specific testing, such as ensuring that latency is less than 10 seconds, or that agent action inputs and outputs meet certain requirements. ## Get Started with Custom Evaluation Criteria Custom evaluations follow a different format from standard expectations. Instead of defining an expectation with a name and an expected value, custom evaluations require individual parameters to define the evaluation requirements. Currently, there are two different types of custom evaluations that you can add to your test metadata. - **String comparison**: Tests a response for a specific string value. The API name for this evaluation is `string_comparison`. - **Numeric comparison**: Tests a response for a specific numeric value. The API name for this evaluation is `numeric_comparison`. ## Use Parameters to Define a Custom Evaluation This example custom evaluation checks if the reply email created by the DraftGenericReplyEmail action mentions the right person. ``` string_comparison operator equals false actual $.generatedData.invokedActions[*][?(@.function.name == 'DraftGenericReplyEmail')].function.input.recipient true expected Jon false ``` This example of a custom evaluation has three different parameters: an actual value, an expected value, and an operator to compare them. Each parameter is defined with a `name` field, a `value` field, and an `isReference` field. The parameters are set individually using the `AiEvaluationExpectationParameter` format. For details, see the [Metadata reference](/docs/ai/agentforce/references/testing-api/testing-metadata-reference.html). This example evaluation uses the `equals` operator. This means the test case checks if the `actual` value from the agent matches the `expected` value. All string comparison operators are case sensitive. There are different valid operators for string comparison and numeric comparison evaluations. The valid string comparison operators are: - `equals`: Checks if the `actual` value directly matches the `expected` value. - `contains`: Checks if the `actual` value contains the `expected` value. - `startswith`: Checks if the `actual` value begins with the `expected` value. - `endswith`: Checks if the `actual` value ends with the `expected` value. The valid numeric comparison operators are: - `equals`: Checks for numerical equality. - `greater_than_or_equal`: Checks if the `actual` value is greater than or equal to (`>=`) the `expected` value. - `greater_than`: Checks if the `actual` value is greater than (`>`) the `expected` value. - `less_than`: Checks if the `actual` value is less than (`<`) the `expected` value. - `less_than_or_equal`: Checks if the `actual` value is less than or equal to (`<=`) the `expected` value. **note:** Each parameter field is limited to 100 characters. The actual value is retrieved with a JSONPath expression. This expression enables you to automatically point to the data you want to test from the [Get Test Results](/docs/ai/agentforce/references/testing-api/testing-connect-reference.html#get-test-results) resource in Connect API. For details on how to construct a JSONPath expression, see [Dynamically Reference Generated Data](#dynamically-reference-generated-data). ### Dynamically Reference Generated Data In most custom evaluations, the `value` for the `actual` result is a JSONPath expression that points to generated data. This is runtime data from the `generatedData` object returned by the [Get Test Results](/docs/ai/agentforce/references/testing-api/testing-connect-reference.html#get-test-results) resource. For this expression to dynamically reference data, `isReference` must be set to `true`. Most JSONPath expressions for custom evaluations follow a pattern. ``` $.generatedData.invokedActions[*][?(@.function.name == '{ACTION}')].{DYNAMIC_DATA} ``` You can show the generated JSON data when retrieving test results via Agentforce DX. To show the generated JSON, add the `--verbose` flag to a `agent test run` command. For more information, see [Customize the Agent Test Spec](https://developer.salesforce.com/docs/ai/agentforce/agent-dx/agent-dx-test-customize.md). #### Example JSONPath Expressions Get the `query` input for the `namespace_actionName` action: ``` $.generatedData.invokedActions[*][?(@.function.name == {namespace_actionName})] .function.input.query ``` Get the `result` output for the `namespace_actionName` action: ``` $.generatedData.invokedActions[*][?(@.function.name == 'namespace_actionName')] .function.output.result ``` Get the `value` from the first `additionalContext` item for the `namespace_actionName` action: ``` $.generatedData.invokedActions[*][?(@.function.name == {namespace_actionName})] .function.output.additionalContext[0].value ``` For information on JSONPath operators, see the [official documentation](https://javadoc.io/doc/com.jayway.jsonpath/json-path/2.2.0/com/jayway/jsonpath/JsonPath.html). ## Example Test Case Definition This is a complete test case metadata file that demonstrates standard expectations, out-of-the-box metrics, custom evaluation criteria, and context variables. ``` My first Salesforce Agent test Agent_Sanity AGENT Sales_Agent v1 1 Summarize the Global Media account OrchestrationStage 001SB00000MC0yrYAD_test EndUserLanguage Spanish topic_sequence_match OOTBSingleRecordSummary action_sequence_match ['IdentifyRecordByName', 'SummarizeRecord'] bot_response_rating Summarization of the Global Media account including important points coherence output_latency_milliseconds 2 List contact names associated with Global Media account topic_sequence_match GeneralCRM action_sequence_match ['IdentifyRecordByName', 'QueryRecords'] bot_response_rating should respond with list of contacts string_comparison operator equals false actual $.generatedData.invokedActions[*][?(@.function.name == 'DraftGenericReplyEmail')].function.input.recipient true expected Jon false ``` # ADL Agent Example - Demystify Jargon with Knowledge Ensure that your [grounded](https://help.salesforce.com/s/articleView?id=ai.agent_parent_data.htm&type=5) agent understands your organization's evolving jargon, domain-specific terms, or updated product names — without having to update and reindex your information sources. ## The Problem Grounded agents are grounded in information, either using an [Agentforce Data Library](https://help.salesforce.com/s/articleView?id=ai.data_library_parent.htm&type=5) or [Retrieval Augmented Generation](https://help.salesforce.com/s/articleView?id=ai.generative_ai_rag.htm&language=en_US&type=5). However, the grounding information might contain only formal names while customers use jargon, acronyms, or new names. Even if the grounding information contains both correct and jargon terms, it might be [indexed](https://help.salesforce.com/s/articleView?id=data.c360_a_search_index_manage.htm&type=5) only on the correct names — so the retriever or data library misses relevant chunks even though correct information exists. Updating and reindexing an agent's grounding information (which typically contains thousands of articles) can be time-consuming and involve special roles. Plus, jargon can change quickly! ## The Solution One solution is to map informal to correct terms before retrieval. Maintain a lightweight old-to-new term map in Salesforce Knowledge (or other object), fetch the mapped information once per session, and hydrate the prompt so the agent can translate user questions when necessary. By telling your agent to map jargon to correct terms before fetching grounding content, your agent can find relevant chunks in the search index and reduce false “irrelevant question” routing. By using Knowledge (or other object), business users rather than IT can make terminology updates. ### When to Map Terms Before Retrieval This solution is a good fit when: - Your grounding content is mostly correct, but users ask questions with terms that differ from your indexed content. - Product names, acronyms, or internal jargon change frequently, but the core content in your data library is still accurate. - Your terminology map isn't so large that it impacts your agent's [context engineering](https://help.salesforce.com/s/articleView?id=ai.agent_context_engineering.htm). ### When Not to Use This Solution This solution is **not** a good fit when: - Your terminology map is so large it starts to affect your agent's performance. - Your information sources are easy to update and re-index. ## Set up A Salesforce Developer Org To follow along with this example, you can sign up for a free Salesforce Developer Edition org, then configure the org with Data Cloud and Agentforce. **note:** Instead of signing up for a new org, you can re-use an existing developer org. For a complete Agentforce implementation guide, see [Create Agents in Record Time with Agentforce Implementation Guides](https://help.salesforce.com/s/articleView?id=ai.agent_resources.htm&type=5). ### Sign Up for a Developer Org 1. Go to the [signup page](https://www.salesforce.com/form/developer-signup/?d=pb) to sign up for a Developer Edition org with Agentforce and Data Cloud. 2. Fill out the form and submit it. 3. Look for a welcome email from Salesforce in your inbox. 4. Verify your account using the verification link in the email. 5. When prompted, set a new password and select a security question for your Developer Edition org. Then complete the login process. 6. Keep track of your username and password so that you can log in again later from the Salesforce [login page](http://login.salesforce.com). ### Verify Data Cloud in Your Org Data Cloud is required for essential Einstein generative AI and Agentforce functionality, such as the Trust Layer, agent event logs, and consumption billing tracking. In our example, we need Data Cloud for Agentforce Data Library. Verify your Data Cloud installation. From Setup, in the Quick Find box, enter **Data Cloud**, and then select **Data Cloud Setup Home**. Verify that a home org is created on the Data Cloud Setup Home page, with a home org ID, a home org instance, and a tenant endpoint. If Data Cloud isn't set up, in Set Up Data Cloud, click **Get Started**. Setup can take about 10 minutes. ### Enable Einstein Generative AI Turn on Einstein to use generative AI features, including Agentforce. 1. From Setup, in the Quick Find box, enter `Einstein Setup`, and then select **Einstein Setup**. 2. Enable **Turn on Einstein**. 3. Refresh the page. After you turn on Einstein, it can take a few minutes to sync Einstein and Data Cloud. ### Enable Agentforce Turn on Agentforce to start building, customizing, testing, and launching AI agents. 1. From Setup, in the Quick Find box, enter Agent, and then select **Agentforce Agents**. If you don’t see Agents in Setup, verify that Einstein Generative AI is enabled for your org. 2. To enable Agentforce, turn on **Agentforce**. After you enable Agentforce, refresh the page to see the New Agentforce Builder panel. ## Create Your Agent Use the standard Agentforce Service Agent template. ### Aura & Ash's Business Challenge Aura & Ash sells skincare products and has a service agent that helps customers select, combine, and use products. Because product names frequently change, and the company wants to stay current with viral product nicknames, Aura & Ash will create a Knowledge article to map old and new product names. ### Create a Default Service Agent 1. In the New Agentforce Builder panel, click **Let's Go**. To access the Agentforce Builder later, from the App Launcher, find and select **Agentforce Studio**, and then click **Agents**. 2. Click **New Agent**, then select **Agentforce Service Agent**. 3. Name your agent `Aura & Ash Service Agent` and accept the developer default. 4. Click **Select User**, then select `EinsteinServiceAgent` user. 5. Click **Let's Go**. The agent opens in canvas view. You can see that the Service Agent template provides typical subagents for a service agent. Leave your new agent open in a browser tab. ## Create Your Data Library To ground your agent’s responses in Aura & Ash's product information, you'll create a [data library](https://help.salesforce.com/s/articleView?id=ai.data_library_parent.htm&type=5) and upload a PDF. 1. Download the [Aura_Ash_Product_Instructions.pdf](https://resources.docs.salesforce.com/rel1/doc/en-us/static/pdf/Aura_Ash_Product_Instructions.pdf). This PDF provides brief usage instructions for skincare products, but uses the old product names. 2. Leave your agent open in a browser tab. From Setup, in the Quick Find box, enter `Data Library`, and then select **Agentforce Data Library**. 3. Click **New Library**. 4. For the library name, enter `Aura and Ash Products`. The API name is automatically populated. 5. For the description, enter `Sources for Aura & Ash Customer Service agent’s product usage agent`. 6. Save your changes. 7. In the Data Type field, select **Files**. 8. Click **Select Files**, then upload the `Aura & Ash Product Instructions.pdf` file from wherever you saved it on your computer. When your file is finished uploading, click **Done**. Salesforce takes some time to create your data library. Wait until the Status is `Ready` — you might need to refresh your page. ![ADL ready](https://developer.salesforce.com/media/agent-script/rag-example/ADL_ready.png) ### Assign Your Data Library to the Agent Now that you’ve created your data library, add it to your agent. 1. From your agent's Explorer panel, expand **Data** and select **Data Library**. 2. Select the **Aura & Ash Products** library. If you don’t see your library, refresh the page. 3. Leave the Show Sources setting disabled. When this setting is enabled, your agent shows the sources for every answer it generates with your data library. For the Aura & Ash use case, we'll leave that setting disabled because we’re using a single PDF for all answers. 4. In the upper right, click **Save**. ### Test Your Agent Your agent is now grounded on Aura & Ash product instructions and can answer customer questions, provided customers use legacy product names. 1. Click **Preview** and click **Refresh** (circular arrow). 2. In the test window, enter this text: `How do I use the Hand & Cuticle Oil`. 3. The agent responds with information grounded in your library, such as massaging a few drops into your nails and allowing time for absorption. 4. Now, repeat the question with the product's new name by entering `How do I use Iron Grip Rescue Fuel?`. The agent doesn't have your product's new name and responds that it can't help. We'll download the product's old and new name map in the next step, so that the agent can find the relevant information. **note:** By testing the agent with new terms before you map them, you're ensuring that your agent doesn't already know your new terms. Sometimes, jargon or domain-specific knowledge is still part of the public knowledge set on which the LLM was trained. In that case, the LLM might correctly link a customer's jargon term to your data library's knowledge without using your terminology map. It's important to verify a failure case first, so you can validate your solution later. ## Create a Terminology Map with Salesforce Knowledge Your agent is grounded on Aura & Ash's product usage information, but your data library uses the old product names. Real-world data libraries can be large and complex to configure. It's often much easier to provide an agent with a simple terminology map that a business user can update, rather than rewriting and rebuilding a data library. ## Set up Salesforce Knowledge To create a Knowledge article, set up Salesforce Knowledge, grant yourself and your agent user permissions on the `knowledge__kav` object, create a template, and grant the agent user access to Knowledge. **note:** This example walks you through a basic Knowledge setup that meets the needs of this example. If your organization already uses Knowledge, you can use an existing article type. ### Assign Yourself the Knowledge User License Assign your user the Knowledge user license so you can create Knowledge articles. 1. From **Setup**, in the Quick Find box, enter and select **Users**. 1. Next to your user name, click **Edit**. 1. Select the **Knowledge User** checkbox. 1. Click **Save**. ### Enable Salesforce Knowledge 1. From **Setup**, in the Quick Find box, enter and select **Knowledge Settings**. 2. Select **Yes, I understand the impact of enabling Salesforce Knowledge** and click **Enable Salesforce Lightning Knowledge**, then click **Ok**. ### Create a New Article Layout You need a Knowledge article layout with a text field to hold your map of old and new product names. **note:** This example adds a custom field to the Knowledge layout. If your organization already has layouts defined, consider reusing an existing layout. 1. In Setup, select **Object Manager**. 2. In Quick Find, enter and select **Knowledge** (API name `Knowledge__kav`). 3. Select **Fields & Relationships** then click **New**. 4. Select **Text Area** (Long) and click **Next**. 5. Enter this information: | Field | Value | | :---- | :---- | | Field Label | `Alternate Product Names` | | Description | `New or alternate names, acronyms, and slang terms for products`| | Visible lines| `40` | | Field Name | Accept `Alternate_Product_Names__c`| 6. Leave all other fields the same and click **Next**. 7. Ensure the new field is visible to the Einstein Agent User and click **Next**. 8. Select the box next to **Knowledge Layout** and click **Save**. The new field is created and added to the Knowledge page layout. ### Grant Your Agent Permissions to `Knowledge__kav` Your agent user needs read permissions on the Knowledge object,`Knowledge__kav`, but only when operating the Aura & Ash agent. 1. From **Setup**, in the Quick Find box, enter and select **Permission Sets**. 2. Click to open the **Agentforce Agent Aura_Ash_Service_Agent** Permission set. 3. Click to open **Object Settings**. 4. Scroll down, then click to open **Knowledge**, with the API name `Knowledge__kav`. 5. Click **Edit**. 6. Under Object Permissions, for Read and View all Fields, select **Enabled**. 7. Click **Save**. ![ADL ready](https://developer.salesforce.com/media/agent-script/rag-example/agent_perms.png) **note:** Always give your agent user the fewest permissions it needs to do its job. In this example, our EinsteinServiceAgent user doesn't need write access. For more information about service agent permissions, see [(Help:) Best Practices for Agent User Permissions](https://help.salesforce.com/s/articleView?id=ai.agent_user.htm&type=5). ### Give Your Agent User Access to Knowledge You can't give the agent user a Knowledge license, but you can grant the Allow View Knowledge app permission. 1. From **Setup**, in the Quick Find box, enter and select **Users**. 2. Click to open your EinsteinServiceAgent name. 3. Expand the list of permission set assignments, then click to open the **Service User** permission set. 4. Click to open **App Permissions**. 5. Click **Edit**. 6. Select **Allow View Knowledge**. 7. Click **Save**. Your agent user has permissions to view Knowledge articles. For more information about agent user permissions, see [(_Help_):Best Practices for Agent User Permissions](https://help.salesforce.com/s/articleView?id=ai.agent_user.htm&type=5). ### Create a Knowledge Article 1. Download the document [Aura_Ash_New_Names.pdf](https://resources.docs.salesforce.com/rel1/doc/en-us/static/pdf/Aura_Ash_New_Names.pdf). This document maps old product names to new product names. 2. From the app menu, enter and select **Knowledge**, then click **New** to create a new Knowledge document. 3. Name your document `Aura & Ash Updated Product Names` and accept the default URL name. 4. In the field Alternate Product Names, paste the entire contents of the `Aura & Ash New Names.pdf`, including the instructions. ![script added](https://developer.salesforce.com/media/agent-script/rag-example/new_knowledge.png) 5. Click **Save**. 6. Return to the list of Knowledge articles, then select and publish your article. 7. Copy your Knowledge article number - you'll need it to create your agent action. ![script added](https://developer.salesforce.com/media/agent-script/rag-example/article_number.png) Your Knowledge Article is published and ready to use in a Flow. ## Create a Flow to Fetch the Knowledge Article Create a flow that looks up your knowledge article by article ID. 1. From Setup, in the Quick Find box, enter **Flows**, and then select **Flows**. 2. Click **New Flow**. 3. Select the **Autolaunched Automations** category, and then select **Autolaunched Flow (No Trigger)**. 4. Add a Get Records Element. 1. For the label, enter `Get Knowledge Article by ID.` 2. For the object, select **Knowledge** (**Knowledge\_\_kav)**. 5. Select the knowledge record by article number - For the condition requirements, leave **All Conditions Are Met (And)** selected. - For the field, select **Article Number**. - For the operator, select **Equals**. - For the value, add a new resource with these values: | Field | Value | | :---------------------------- | :------------------ | | Resource Type | Variable | | API Name (case-sensitive) | articleNumber | | Description | The article number | | Data Type | Text | | Availability Outside the Flow | Available for input | 6. Click **Done** 7. Create a variable to store the new product names. - Under How to Store Record Data, select **Choose fields and assign variables (advanced)**. - Under Where to Store Field Values, select **In separate variables**. - Under Select Variables to Store Knowledge Fields, for Field, select **Alternate_Product_Names\_\_c**. - For Variable, create a new resource. | Field | Value | | :---------------------------- | :------------------------------------------- | | Resource Type | Variable | | API Name (case-sensitive) | alternateProductNames | | Description | List of products with their alternate names. | | Data Type | Text | | Default Value | leave blank | | Availability Outside the Flow | Available for output | 1. Click **Done**. 2. Select **When no records are returned, set specified variables to null**. 3. Save the flow. Use the name `Alternate Product Names` and accept the api name. ### Test Your Flow To test your flow and make sure your agent has all of the required permissions to run it, debug the flow as your agent user. 1. Give yourself permission to debug your flow as another user. - From Setup, in the Quick Find box, enter `Process Automation`, and then select **Process Automation Settings**. - Select **Let admins debug flows as other users** then click **Save**. 2. In Flow Builder, click **Debug**. - Select **Run automation as another user**, and then select your EinsteinServiceAgent User. - For articleNumber, enter the article number for your Aura & Ash Updated Product Names article. You saved this number in a previous step. - Click **Run** and expand Details to see the returned list of product names. 3. To activate the flow, click **Activate**. **Tip**: If you get an error running the flow as the EinsteinServiceAgent user, switch to your user. If the flow is successful running under your user, check the EinsteinServiceAgent's permissions. ## Update Your Agent to Fetch and Store the Mapped Product Names Now that you've created a Knowledge article to map old and new product names, then created a flow to fetch the names, you're ready to ground your agent with the new product names. First, you'll create a variable to store the mapped names. Then, you'll create an agent action based on your flow. Finally, you'll update your agent to run the action and use the mapped names to find answers to your customer's questions. ### Create the Old2NewProductNames Variable You'll use the Old2NewProductNames variable to store the mapped product names that your flow returns from the Knowledge article. 1. In your agent's Explorer panel, click **Variables**. 2. In the upper right of the Canvas, click **New**, then select **Create Custom Variable**. 3. Use these values to create your variable. | Field | Value | |-----------------|-----------------------------------------------------| | Name and API Name | Old2NewProductNames | | Data Type | String | | Description | Maps the old product names to the new product names. | | Default value | NotRun | 4. Click **Create**, then save your agent. Your **Old2NewProductNames** variable is created. ### Create the GetNewProductNames Action 1. In Agentforce Builder, from the Explorer tab, expand **Subagents** \> **General FAQ.** 2. Click the **plus sign** **(+)** next to General FAQ and select **Create New Action**. 3. Set these fields on your action. | Field | Value | |---------------|-------------------------------| | Action Name | GetNewProductNames | | Description | Get the new names for products.| 4. Click **Create and Open**. 5. For the reference action type, select **Flow**. 6. For the reference action, select your **Alternate Product Names** flow. 7. Under Inputs, for articleNumber, select **Require Input to execute action**. 8. Under Outputs, for alternateProductNames, select **Show in conversation**. 9. Click **Save**. ### Deterministically Run the GetNewProductNames Action Run your GetNewProductNames action in the reasoning instructions, then store the output list of mapped names in the Old2NewProductNames variable. To improve performance, only run the action once by checking if the Old2NewProductNames variable is `NotRun`. 1. Switch to Script mode. 2. In the GeneralFaq subagent, below `instructions: ->` and above `| Your job is solely to help with issues`, paste these instructions. ```agentscript if @variables.Old2NewProductNames == "NotRun": run @actions.GetNewProductNames with articleNumber = "000001000" set @variables.Old2NewProductNames = @outputs.alternateProductNames ``` 3. Align the script with the pipe ("`|`") character below. 4. If needed, replace **000001000** with your Knowledge article's article number that you copied in a previous step. Your script should look like this. ![script added](https://developer.salesforce.com/media/agent-script/rag-example/action_script.png) 5. Save the agent, then verify in Canvas view. ![script added](https://developer.salesforce.com/media/agent-script/rag-example/action_script_canvas.png) ### Instruct the Agent to Consider New Product Names 1. In Canvas, click your cursor after the first sentence, which says something like `Your job is solely to help with issues and answer questions about the company's products, procedures, or policies by searching knowledge articles.` 2. Press **Enter/Return**, then paste this text. `Product names have changed. Customers might use a new product name in their questions. When a mentioned product is not found in the knowledge content, consult` 3. Enter `"@"` to bring up the context menu, then scroll down to **This Agent's Variables** and select **Old2NewProductNames**. 4. Paste this text `to determine whether it maps to an older product name. If a mapping exists, use the older product name when searching knowledge articles.` 5. Click **Save**. Your Canvas view should look like this. ![canvas view](https://developer.salesforce.com/media/agent-script/rag-example/variable_canvas_view.png) ## Test Your Agent Your agent is now grounded on Aura & Ash product instructions and new product names. The agent can answer customer questions for both legacy and new product names. 1. Click **Preview**, then next to **Set Context**, click **Refresh** (circular arrow). 2. Enter the prompt: `Tell me about the Iron Grip Rescue Fuel`. 3. The agent responds with information grounded in your library for the old product name, Hand & Cuticle Oil. You can see that your Get Alternate Product Names action is run only once. ![Final query](https://developer.salesforce.com/media/agent-script/rag-example/final_utterance.png) ## More Information This example's Agent Script uses these [patterns and best practices](https://developer.salesforce.com/docs/ai/agentforce/agent-script/patterns/ascript-patterns.md). | Pattern | Usage in Script | | -------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | [Fetch Data Before Reasoning](https://developer.salesforce.com/docs/ai/agentforce/agent-script/patterns/ascript-patterns-fetch-data.md) | The flow runs **before** the prompt is sent to the LLM, so the agent always has our updated product names. | | [Using Conditionals](https://developer.salesforce.com/docs/ai/agentforce/agent-script/patterns/ascript-patterns-conditionals.md) | The `if @variables.Old2NewProductNames == "NotRun"` check ensures the action is run only once, reducing processing and potentially cost. | | [Using Variables Effectively](https://developer.salesforce.com/docs/ai/agentforce/agent-script/patterns/ascript-patterns-variables.md) | `Old2NewProductNames` has a default value, so we can check when it's not been used. | | Verify the agent with a known failure case | LLMs can infer a surprising amount of information and have been trained on a vast array of public knowledge. Before injecting the prompt with our product name map, we verified the agent didn't understand the new product names. That way, we're confident that the updated name information is coming from our map, not from inference or public knowledge. | Agent API # Agent API Use Agent API to communicate with AI agents in your org. Get access to your topics and actions in Agentforce by sending messages to AI agents. Create a Salesforce app in your org, generate a token, and then start using the API. To onboard to this API, see [Get Started with the Agent API](/docs/ai/agentforce/guide/agent-api-get-started.html) and [Agent API Examples](/docs/ai/agentforce/guide/agent-api-examples.html). ### Postman Collection The quickest way to get started with the Agent API is with our [Postman collection](https://www.postman.com/salesforce-developers/salesforce-developers/collection/gwv9bjy/agent-api). ### Endpoints * [Start a Session](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=startSession): Start a session with an agent. * [Send a Message (sync)](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=sendMessage): Send a sync message to the agent on an active session. * [Send a Message (streaming)](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=sendMessageStream): Send a streaming message to the agent on an active session. * [End a Session](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=endSession): End a session. * [Submit Feedback](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=submitFeedback): Submit feedback for a message. **Version:** v1.0.0 ## Servers * `https://api.salesforce.com/einstein/ai-agent/v1` Agent API - Production Environment ## Security * `jwtBearer` (http) Salesforce OAuth access token obtained using the JWT Bearer flow. To learn more, see [Get Started with the Agent API](/docs/ai/agentforce/guide/agent-api-get-started.html). * HTTP scheme: bearer ## Operations ### POST Start a session `POST /agents/{id}/sessions` Operation ID: `startSession`. Begin an agent session. The endpoint contains the ID of the Salesforce agent. You can find this ID in the URL of the agent details page. When you select the agent from Setup, use the ID at the end of the URL. #### Parameters * `id` (path, string, required) The ID of the Salesforce agent. You can find this ID in the URL of the agent details page. When you select the agent from Setup, use the ID at the end of the URL. * `Authorization` (header, string, required) Authorization information that contains the JWT. Example: `Bearer •••••`. #### Request body (required) Request payload to initiate a session. Media type: `application/json`. Schema: `StartSessionRequest`. #### Responses * **200** Response to a new session. Headers: * `x-session-mode` (string) Agent session mode. Example: `default` Media type: `application/json`. Schema: `StartSessionSyncResponseMessage`. * **400** Bad Request Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 400, "path": "/v6/00DRM00000067To/sessions/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "BadRequestError", "message": "Bad Request", "timestamp": 1531245973799 } ``` * **401** Access bearer token is missing or invalid Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 401, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "UnauthorizedError", "message": "Access bearer token is missing or invalid", "timestamp": 1531245973799 } ``` * **403** User forbidden from accessing the resource Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 403, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "ForbiddenError", "message": "User forbidden from accessing the resource", "timestamp": 1531245973799 } ``` * **404** Resource not found Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 404, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "NotFoundError", "message": "Resource not found", "timestamp": 1531245973799 } ``` * **422** Any exception that occurred during the request execution Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 422, "path": "v4.0.0/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "RequestProcessingException", "message": "Cannot determine the active version for the agent", "timestamp": 1531245973799 } ``` * **423** Server is busy and cannot process the request at this time Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 423, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "ServerBusyError", "message": "Server is busy and cannot process the request at this time", "timestamp": 1531245973799 } ``` * **429** Too many requests for the server to handle Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 429, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "TooManyRequestsError", "message": "Too many requests for the server to handle", "timestamp": 1531245973799 } ``` * **503** Service is unavailable possibly because Apex or Flow calls timed out Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example_ ``` { "status": 503, "path": "/v1/00DRM00000067To/chatbots/HelloWorldBot/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "ServiceUnavailable", "message": "Service is unavailable possibly because Apex/Flow calls timed out", "timestamp": 1531245973799 } ``` * **default** Something went wrong Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. ### POST Send a message (synchronous) `POST /sessions/{session-id}/messages` Operation ID: `sendMessage`. Send a synchronous message to the agent on an active session. The endpoint contains the ID of the active session, which was returned in the response of the Start Session call. #### Parameters * `session-id` (path, string, required) The ID of the active session, which is the `sessionId` value returned from the Start Session call. * `Authorization` (header, string, required) Authorization information that contains the JWT. Example: `Bearer •••••`. #### Request body (required) Request payload to continue the chat. Media type: `application/json`. Schema: `SendMessageRequest`. #### Responses * **200** Batched Response (Headless) Media type: `application/json`. Schema: `SendMessagesSyncResponseMessage`. * **400** Bad Request Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 400 response._ * **401** Access bearer token is missing or invalid Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 401 response._ * **403** User forbidden from accessing the resource Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 403 response._ * **404** Resource not found Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 404 response._ * **422** Any exception that occurred during the request execution Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 422 response._ * **423** Server is busy and cannot process the request at this time Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 423 response._ * **429** Too many requests for the server to handle Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 429 response._ * **503** Service is unavailable possibly because Apex or Flow calls timed out Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 503 response._ * **default** Something went wrong Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. ### POST Send a message (streaming) `POST /sessions/{session-id}/messages/stream` Operation ID: `sendMessageStream`. Send a streaming message to the agent on an active session. Returns an SSE stream in the response. The endpoint contains the ID of the active session, which was returned in the response of the Start Session call. #### Parameters * `session-id` (path, string, required) The ID of the active session, which is the `sessionId` value returned from the Start Session call. * `Authorization` (header, string, required) Authorization information that contains the JWT. Example: `Bearer •••••`. * `Accept` (header, string, required) Indicates which content type the sender is able to understand. For this endpoint, specify `text/event-stream`. Example: `text/event-stream`. #### Request body (required) Request payload to continue the chat. Media type: `application/json`. Schema: `SendMessageRequest`. #### Responses * **200** OK Media type: `text/event-stream`. Schema: `ServerSentEvent`. * **400** Bad Request Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 400 response._ * **401** Access bearer token is missing or invalid Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 401 response._ * **403** User forbidden from accessing the resource Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 403 response._ * **404** Resource not found Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 404 response._ * **422** Any exception that occurred during the request execution Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 422 response._ * **423** Server is busy and cannot process the request at this time Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 423 response._ * **429** Too many requests for the server to handle Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 429 response._ * **503** Service is unavailable possibly because Apex or Flow calls timed out Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 503 response._ * **default** Something went wrong Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. ### DELETE End an active session `DELETE /sessions/{session-id}` Operation ID: `endSession`. Send a message to the agent to end a session. The endpoint contains the ID of the active session, which was returned in the response of the Start Session call. #### Parameters * `session-id` (path, string, required) The ID of the active session, which is the `sessionId` value returned from the Start Session call. * `Authorization` (header, string, required) Authorization information that contains the JWT. Example: `Bearer •••••`. * `x-session-end-reason` (header, EndSessionReason, required) The reason the session ended. _Example_ ``` UserRequest ``` #### Responses * **200** Batched Response (Headless) Media type: `application/json`. Schema: `SendMessagesSyncResponseMessage`. * **400** Bad Request Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 400 response._ * **401** Access bearer token is missing or invalid Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 401 response._ * **403** User forbidden from accessing the resource Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 403 response._ * **404** Resource not found Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 404 response._ * **422** Any exception that occurred during the request execution Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 422 response._ * **423** Server is busy and cannot process the request at this time Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 423 response._ * **429** Too many requests for the server to handle Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 429 response._ * **503** Service is unavailable possibly because Apex or Flow calls timed out Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 503 response._ * **default** Something went wrong Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. ### POST Submit feedback `POST /sessions/{session-id}/feedback` Operation ID: `submitFeedback`. Submit feedback for a message. Feedback data is stored in Data 360. #### Parameters * `session-id` (path, string, required) The ID of the session, which is the `sessionId` value returned from the Start Session call. * `Authorization` (header, string, required) Authorization information that contains the JWT. Example: `Bearer •••••`. #### Request body (required) The feedback payload. Media type: `application/json`. Schema: `FeedbackMessage`. #### Responses * **202** Feedback successfully accepted. * **400** Bad Request Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 400 response._ * **401** Access bearer token is missing or invalid Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 401 response._ * **403** User forbidden from accessing the resource Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 403 response._ * **404** Resource not found Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 404 response._ * **422** Any exception that occurred during the request execution Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 422 response._ * **423** Server is busy and cannot process the request at this time Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 423 response._ * **429** Too many requests for the server to handle Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 429 response._ * **503** Service is unavailable possibly because Apex or Flow calls timed out Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. _Example: same as POST /agents/{id}/sessions 503 response._ * **default** Something went wrong Headers: * `X-Request-ID` (string) Request ID. A UUID in string format to help with request tracking. Example: `36a73651-a46d-4d16-9a8a-fd436ed62e1a` Media type: `application/json`. Schema: `Error`. ## Schemas ### StartSessionRequest * `externalSessionKey` (_ExternalSessionKey_, required) * `instanceConfig` (_InstanceConfig_, required) * `tz` (_string_) Client timezone where the customer starts the chat. Uses the tz database timezone format. Can be null. Example: `America/Los_Angeles`. * `variables` (_Variables_) * `featureSupport` (_SessionFeature_) * `streamingCapabilities` (_StreamingCapability_) * `bypassUser` (_boolean_) Indicates whether to use the agent-assigned user instead of the logged in user. If set to `true`, the API uses the user associated with the agent. If set to `false`, the API uses the user associated with the token. Set this value to `true` when using the client credentials flow. Defaults to `false`. Example: `true`. ### StartSessionSyncResponseMessage * `sessionId` (_ResponseSessionId_, required) * `_links` (_SyncLinks_, required) * `messages` (_array of AbstractResponseMessage_, required) Array of initial messages. Each message can be one of the following response message types: [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). Minimum: 0. ### Error * `status` (_integer (int32)_, required) HTTP status. * `path` (_string_, required) Request path. * `requestId` (_string_, required) Request ID. A UUID in string format to help with request tracking. * `error` (_string_, required) Error class name. * `message` (_string_, required) Exception message. * `timestamp` (_number_, required) Unix timestamp. _Example_ ``` { "status": 500, "path": "/agents/00DRM00000067To/messages", "requestId": "19c056ab-d909-49df-b976-65e56b6ab214", "error": "InactiveConfigException", "message": "Config is not active", "timestamp": 1531245973799 } ``` ### SendMessageRequest Represents a send message request. * `message` (_AbstractRequestMessage_, required) * `variables` (_Variables_) ### SendMessagesSyncResponseMessage * `messages` (_array of AbstractResponseMessage_, required) Array of response messages. Each message can be one of the following response message types: [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). Minimum: 0. * `_links` (_SyncLinks_, required) ### ServerSentEvent Server sent event (SSE) contents. * `id` (_string_) Event ID. Example: `1692632086370-0`. * `event` (_EventType_, required) * `retry` (_number_) Reserved for future use. * `data` (_CopilotEvent | ErrorEvent_, required) Data associated with this event. One of: `CopilotEvent`, `ErrorEvent`. ### EndSessionReason Type: `string`. Allowed values: `UserRequest`, `Transfer`, `Expiration`, `Error`, `Other`. Example: `Transfer`. ### FeedbackMessage * `feedbackId` (_FeedbackId_, required) * `feedback` (_FeedbackRating_, required) * `text` (_string_) Textual representation of user feedback. Example: `Email looks great.`. * `details` (_object_) Additional details to provide as key value pairs. Maximum properties: 10. _Example_ ``` { "userId": "uid" } ``` ### ExternalSessionKey UUID that you provide for the conversation. You can use this parameter to trace the conversation in your agent's event logs. Type: `string`. Example: `57904eb6-5352-4c5e-adf6-5f100572cf5d`. ### InstanceConfig API configuration parameters. * `endpoint` (_string_, required) My Domain URL for your Salesforce org. From Setup, search for My Domain. Copy the value shown in the Current My Domain URL field. See [Get Started with Agent API](/docs/ai/agentforce/guide/agent-api-get-started.html). Example: `https://d5e000009s7bceah-dev-ed.my.salesforce.com/`. ### Variables Array of custom and context agent variables passed to the agent during a session. See [Agent Variables](https://help.salesforce.com/s/articleView?id=ai.agent_variables.htm). Many variables are read-only and can only be set during the start session call. By default, context variables (which have the `$Context` prefix) aren't editable after the session has started, except for the `$Context.EndUserLanguage` variable. You can only modify editable variables during a send message call. When specifying variables that are derived from custom fields, omit the `__c` suffix. For instance, `Conversation_Key__c` becomes `$Context.Conversation_Key`. This array can be null. Array of `Variable`. ### SessionFeature Defines how the session supports message processing. Type: `string`. Allowed values: `Sync`, `Streaming`. Example: `Sync`. ### StreamingCapability Describes the streaming capabilities. * `chunkTypes` (_array of ChunkType_) Array of chunk types. Minimum: 0. ### ResponseSessionId Agent session ID. Use this value for the session ID when sending messages or ending a session. Type: `string`. Example: `57904eb6-5352-4c5e-adf6-5f100572cf5d`. ### SyncLinks List of Agentforce endpoints for HATEOS compliance. * `self` (_HyperLink_, required) * `messages` (_HyperLink_) * `session` (_HyperLink_) * `end` (_HyperLink_) ### AbstractResponseMessage Response message. Message can be one of the following response message types: [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). * `id` (_MessageId_, required) * `type` (_string_, required) Indicates the type of message. Can be one of the following strings: [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). Example: `Inform`. ### AbstractRequestMessage Represents the message to be sent. Can be one of the following request message types: [Text](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextMessage), [Reply](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AReplyMessage), [Cancel](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ACancelMessage), [TransferFailed](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATransferFailedMessage), [TransferSucceeded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATransferSucceededMessage), [PlanTemplate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3APlanTemplateMessage). * `type` (_string_, required) Request message type. Can be one of the following types: [Text](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextMessage), [Reply](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AReplyMessage), [Cancel](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ACancelMessage), [TransferFailed](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATransferFailedMessage), [TransferSucceeded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATransferSucceededMessage), [PlanTemplate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3APlanTemplateMessage). Allowed values: `Text`, `Reply`, `Cancel`, `TransferFailed`, `TransferSucceeded`, `PlanTemplate`. * `sequenceId` (_SequenceId_, required) _Example_ ``` { "type": "Text", "sequenceId": 1, "text": "Can you provide a summary of my orders?" } ``` ### EventType Type of streaming event. See [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). Type: `string`. Allowed values: `UNKNOWN`, `END_OF_TURN`, `PROGRESS_INDICATOR`, `INFORM`, `INQUIRE`, `CONFIRM`, `FAILURE`, `SESSION_ENDED`, `ERROR`, `ESCALATE`, `TEXT_CHUNK`. ### CopilotEvent Event wrapper. * `timestamp` (_number_) Event timestamp. Example: `1716299066`. * `originEventId` (_EventId_) * `traceId` (_string_) Event trace ID. Example: `69feac6d79e075633486f4f722fd97c3`. * `offset` (_number_) Event offset. * `message` (_AbstractResponseMessage_) Response message. Message can be one of the following response message types: [Inform](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInformMessage), [TextChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ATextChunkMessage), [ValidationFailureChunk](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AValidationFailureChunkMessage), [ProgressIndicator](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AProgressIndicatorMessage), [Inquire](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AInquireMessage), [Confirm](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AConfirmMessage), [Failure](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AFailureMessage), [Escalate](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEscalateMessage), [SessionEnded](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3ASessionEndedMessage), [EndOfTurn](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AEndOfTurnMessage), [Error](https://developer.salesforce.com/docs/ai/agentforce/references/agent-api?meta=type%3AErrorMessage). ### ErrorEvent ### FeedbackId Unique ID to identify the generation. Used to submit feedback. Type: `string`. Example: `9247bbd8-5ed9-11ee-8c99-0242ac120002`. ### FeedbackRating Feedback rating, suggesting a thumbs up or thumbs down. Type: `string`. Allowed values: `GOOD`, `BAD`. ### Variable Custom or context variable passed to the agent during a session. See [Agent Variables](https://help.salesforce.com/s/articleView?id=ai.agent_variables.htm). Many variables are read-only and can only be set during the start session call. By default, context variables (which have the `$Context` prefix) aren't editable after the session has started, except for the `$Context.EndUserLanguage` variable. You can only modify editable variables during a send message call. When specifying variables that are derived from custom fields, omit the `__c` suffix. For instance, `Conversation_Key__c` becomes `$Context.Conversation_Key`. * `name` (_string_, required) API name for the agent variable. Example: `$Context.EndUserLanguage`. * `type` (_string_, required) Variable type. Allowed values: `Object`, `Json`, `Boolean`, `Date`, `DateTime`, `Money`, `Number`, `Text`, `Ref`, `List`. Example: `Text`. * `value` (_string_, required) Variable value. Example: `en_US`. ### ChunkType Defines the types of stream chunks you'd like to receive when streaming. Type: `string`. Allowed values: `Text`. ### HyperLink Hyperlink object included in the links schema. * `href` (_string_) Link to the endpoint. Example: `https://api.salesforce.com/sessions`. ### MessageId UUID that references this message. Type: `string`. Example: `a133c185-73a7-4adf-b6d9-b7fd62babb4e`. ### SequenceId Client-generated sequence number of the message in a session. Increase this number for each subsequent message. Type: `number`. Example: `1`. ### EventId Unique ID to identify the event. Type: `string`. Example: `auMZc8ZRv37sIW2iJKq3M9MFx1YvV11A2x`. ### CancelMessage Represents a cancel message request. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) ### ReplyMessage Used when answering a question with a choice of multiple records. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) * `reply` (_array of TargetTypeMessage_, required) Minimum items: 1. ### EndOfTurnMessage Represents the end of the turn. Includes all fields of `AbstractResponseMessage`. ### ProgressIndicatorMessage Represents a progress indicator. Includes all fields of `AbstractResponseMessage`. * `indicatorType` (_ProgressIndicatorType_, required) * `message` (_string_, required) Status message sent to the user. Example: `Looking up your order`. ### ProgressIndicatorType Indicates the type of progress indicator. Type: `string`. Allowed values: `ACTION`. Example: `ACTION`. ### PlanTemplateMessage Represents a plan template message. Represents the type of message to be sent by client when it wants to execute an existing plan. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) * `details` (_object_, required) Represents details of plan to be executed. Plan templates are metadata and available to planner service. * `planId` (_string_) ID of the plan template. * `intent` (_string_) A string representing the user intent behind this plan. * `userUtterance` (_string_) User utterance that should be used in conversation history as a result of executing this plan. * `variables` (_object_) Contains name value pairs capturing the variable substitutions in the plan. ### TextChunkMessage Represents a chunk of the text response. Includes all fields of `AbstractResponseMessage`. * `offset` (_number_, required) Offset value. * `message` (_string_, required) Text chunk message. * `formatType` (_TextFormatType_, required) ### TextFormatType The text format type. Type: `string`. Allowed values: `Unknown`, `Text`. ### ValidationFailureChunkMessage Indicates that there was a failure validating the agent's response. If you receive a validation failure chunk, remove all previously rendered chunks and display only the new streamed content. Includes all fields of `AbstractResponseMessage`. * `offset` (_number_, required) Token offset value. * `reason` (_string_) Reason for validation failure. Example: `UNGROUNDED`. ### InformMessage Informs caller of response. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `planId` (_PlanId_) * `isContentSafe` (_ContentSafety_, required) * `message` (_string_, required) Example: `Great, the annual revenue for the specified account has been updated to $1,000,000`. * `result` (_array of SourceTypeMessage_) Array of results. Minimum items: 1. * `citedReferences` (_array of CitedReference_) Array of citations. Minimum items: 0. ### InquireMessage Indicates that more information is required. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `planId` (_PlanId_) * `isContentSafe` (_ContentSafety_) * `message` (_string_) The message string. * `collect` (_array of InquireCollectMessage_, required) List of data to be collected. Minimum items: 0. ### InquireCollectMessage Inquire type * `targetType` (_TargetTypeId_, required) * `targetProperty` (_TargetPropertyId_) * `data` (_SourceTypeMessage_) ### ConfirmMessage Indicates that the agent is asking the user to verify that an action should be taken. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `planId` (_PlanId_) * `isContentSafe` (_ContentSafety_) * `message` (_string_) * `confirm` (_array of TargetTypeMessage_, required) List of data to be collected. Minimum items: 1. ### ErrorMessage Indicates there was an error in the response. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `httpStatus` (_integer (int32)_, required) Error HTTP status code. Example: `500`. * `traceId` (_string_) Error trace ID. Example: `69feac6d79e075633486f4f722fd97c3`. * `error` (_string_, required) Error class name. Example: `NullPointerException`. * `message` (_string_, required) Error message. Example: `Something went wrong.`. * `timestamp` (_number_) Error UNIX timestamp. Example: `1531245973799`. * `expected` (_boolean_, required) Indicates whether the error was expected. Example: `true`. ### RichContentCapability * `messageTypes` (_array of MessageTypeCapability_, required) Minimum: 1. ### MessageTypeCapability * `messageType` (_MessageType_, required) * `formatTypes` (_array of FormatTypeCapability_, required) Minimum: 1. ### FormatTypeCapability * `formatType` (_FormatType_, required) ### MessageType Message type that supports rich content output formats. * `ChoicesMessage`: Represents multiple choice content. Type: `string`. Allowed values: `ChoicesMessage`. Example: `ChoicesMessage`. ### FormatType The rendering format of a message. Describes how the message looks. Type: `string`. Allowed values: `MessageDefinition`, `Text`. Example: `MessageDefinition`. ### PlanId Unique ID to identify the plan. Type: `string`. Example: `9247bbd8-5ed9-11ee-8c99-0242ac120002`. ### ContentSafety Indicates whether the content is deemed as safe. A false value doesn't necessarily mean that the content isn't toxic. Type: `boolean`. Example: `true`. ### CitedReference * `type` (_string_, required) Type of citation. This value can be either a CRM record (`record`) or an external link (`link`). Allowed values: `record`, `link`. * `value` (_string_, required) External link address. * `recordId` (_string_) Salesforce org record ID. * `label` (_string_) UI label for citation. * `inlineMetadata` (_array of InlineReferenceMetadata_) Inline metadata information used for inline citations. ### InlineReferenceMetadata * `claim` (_string_, required) Text from the agent response relevant to this reference. * `location` (_integer_, required) Index location for where this citation should be placed. ### SourceTypeMessage Bundle for a source type. * `type` (_SourceTypeId_, required) * `property` (_SourcePropertyId_) * `value` (_TypeValue_, required) ### SourceTypeId The action type ID. See [Agent Actions](https://help.salesforce.com/s/articleView?id=ai.copilot_actions.htm). Type: `string`. Example: `copilotActionOutput/EmployeeCopilot__UpdateRecordFields`. ### SourcePropertyId The action property ID. See [Agent Actions](https://help.salesforce.com/s/articleView?id=ai.copilot_actions.htm). Type: `string`. Example: `result`. ### TargetTypeId The action type ID. See [Agent Actions](https://help.salesforce.com/s/articleView?id=ai.copilot_actions.htm). Type: `string`. Example: `@aiFunctionInput/BookFlight`. ### TargetTypeMessage Bundle for a target type. * `type` (_TargetTypeId_, required) * `property` (_TargetPropertyId_) * `value` (_TypeValue_, required) ### TargetPropertyId The action property ID. See [Agent Actions](https://help.salesforce.com/s/articleView?id=ai.copilot_actions.htm). Type: `string`. Example: `flightInfo`. ### TypeValue A type value. Type: `any`. Example: `a free form string or an object or an array`. ### InReplyToMessageId Message ID of the previous response you are replying to. Type: `string`. Example: `a133c185-73a7-4adf-b6d9-b7fd62babb4e`. ### BooleanVariable Includes all fields of `Variable`. * `value` (_boolean_, required, nullable) Boolean value. Example: `true`. ### DateVariable Includes all fields of `Variable`. * `value` (_string_, required, nullable) Date in the ISO\_LOCAL\_DATE format, 'YYYY-MM-DD'. Example: `2021-09-21`. ### DateTimeVariable Includes all fields of `Variable`. * `value` (_string_, required, nullable) Datetime in the ISO\_LOCAL\_DATE\_TIME format, 'YYYY-MM-DDTHH:MM:SS'. Example: `2018-09-21T14:30:00`. ### MoneyVariable Includes all fields of `Variable`. * `value` (_string_, required, nullable) Money in the format, '3\_LETTER\_CURRENCY\_CODE AMOUNT'. Example: `USD 10.40`. ### NumberVariable Includes all fields of `Variable`. * `value` (_number_, required, nullable) Variable value in number format. Example: `10`. ### TextVariable Includes all fields of `Variable`. * `value` (_string_, required, nullable) Variable value in text format. Example: `Thanks for your order!`. ### ObjectVariable Includes all fields of `Variable`. * `value` (_array of Variable_, required) Variable value as an object. _Example_ ``` [ { "name": "fullName", "type": "text", "value": "Matt Smith" } ] ``` ### RefVariable Includes all fields of `Variable`. * `value` (_string_, required, nullable) Variable value in reference ID format. Example: `1M5xx000000000BCAQ`. ### ListVariable Includes all fields of `Variable`. * `value` (_array of object_, required, nullable) Array of objects. _Example_ ``` [ { "type": "ref", "value": "1M5xx000000000BCAQ" } ] ``` ### JsonVariable Includes all fields of `Variable`. * `value` (_object_, required) Variable value in JSON format. ### Referrer * `type` (_string_, required) Referrer type. Allowed values: `Salesforce:Core:Bot:Id`, `Salesforce:BotRuntime:Session:Id`. Example: `Salesforce:Core:Bot:Id`. * `value` (_string_, required) ID of referrer. Example: `string`. ### TransferFailedMessage Represents a transfer failed message. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) * `reason` (_string_, required) Reason for the failed transfer. Allowed values: `NoAgentAvailable`, `Error`. Example: `NoAgentAvailable`. * `description` (_string_, nullable) Description of why the transfer failed. ### TransferSucceededMessage Represents a transfer succeeded message. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) ### TextMessage Represents a text request. Includes all fields of `AbstractRequestMessage`. * `inReplyToMessageId` (_InReplyToMessageId_) * `text` (_string_, required) Text reply to the agent. ### SessionEndedMessage Indicates the session has ended. Includes all fields of `AbstractResponseMessage`. * `reason` (_string_, required) Reason the session ended. Allowed values: `ClientRequest`, `TransferFailedNotConfigured`, `Action`, `Error`, `InfiniteLoopDetected`. Example: `ClientRequest`. * `feedbackId` (_FeedbackId_) ### FailureMessage Indicates that something didn't execute properly. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `message` (_string_) * `planId` (_PlanId_) * `isContentSafe` (_ContentSafety_) * `code` (_string_, required) Allowed values: `ACTION_FAILED`, `ESCALATE`. * `errors` (_array of string_) Failure information. ### EscalateMessage Indicates that a human rep should handle this request. The escalation message is automatically translated based on the end user's language setting. If the language isn't supported, the original message is returned without translation. Includes all fields of `AbstractResponseMessage`. * `feedbackId` (_FeedbackId_, required) * `targets` (_array of object_, required) Array of transfer targets. Minimum: 0. * `type` (_string_, required) Type of the transfer target. Allowed values: `Salesforce:Core:Bot:Id`, `Salesforce:Core:Queue:Id`, `Salesforce:Core:Skill:Id`, `Salesforce:Core:Flow:Id`. Example: `Salesforce:Core:Bot:Id`. * `value` (_string_, required) ID of the transfer target. ### Status * `status` (_string_, required) Health status of Agent API. Allowed values: `UP`, `DOWN`. Example: `UP`. # Agent API Considerations Review these considerations before you use the Agent API. ## Supported Agent Types The Agent API isn’t supported for agents of type “Agentforce (Default)”. ## Usage and Billing Agent API usage impacts credit consumption as described in the following Salesforce help topic: [Generative AI Usage and Billing](https://help.salesforce.com/s/articleView?id=ai.generative_ai_usage.htm). ## API Timeout The Agent API has
[...]
